
#include "SystemFont.h"

SystemFont::SystemFont(HWND *hWnd, TCHAR *szPanGramma) : hFont(0), hCurFont(0), hWnd_(hWnd), hDc(0)
{
	NONCLIENTMETRICS ncm;
#if _WIN32_WINNT < 0x0600
	ncm.cbSize = sizeof(NONCLIENTMETRICS);
	SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncm, NULL);
#else
	ncm.cbSize = sizeof(NONCLIENTMETRICS) - sizeof(ncm.iPaddedBorderWidth);
	SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS) - sizeof(ncm.iPaddedBorderWidth), &ncm, NULL);
#endif

	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osvi);

#if _WIN32_WINNT >= 0x0600
	if(osvi.dwMajorVersion > 5)//Vista, 2008, Seven, 2008 R2, NT+
	{
		ncm.cbSize = sizeof(NONCLIENTMETRICS);
		SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncm, NULL);
	}
#endif
	hFont = CreateFontIndirect(&ncm.lfMessageFont);

	iLetterXsize = GetTextWidth(szPanGramma) / lstrlen(szPanGramma);
}

SystemFont::~SystemFont()
{
	if(hFont)
		DeleteObject(hFont);
	hFont = 0;
}

HFONT *SystemFont::GetFont()
{
	return &hFont;
}

int SystemFont::GetAverageLetterWidth()
{
	return iLetterXsize;
}

long SystemFont::GetFontHeight()
{
	return TextSize.cy;
}

long SystemFont::GetTextWidth(TCHAR *szTextSample)
{
	hDc = GetDC(*hWnd_);
		hCurFont = (HFONT)SelectObject(hDc, hFont);
		GetTextExtentPoint32(hDc, szTextSample, lstrlen(szTextSample), &TextSize);
		SelectObject(hDc, hCurFont);
	ReleaseDC(*hWnd_, hDc);

	return TextSize.cx;
}