﻿
#include "UserControl.h"

UserControl::UserControl(TCHAR *lpClassName, DWORD dwStyle, HWND hWndParent, int ID, HINSTANCE hInst) : hWndUcParent(hWndParent), hWnd(HWND_DESKTOP)
{
	UcPos.x = UcPos.y = CW_USEDEFAULT;
	UcSize.cx = UcSize.cy = CW_USEDEFAULT;
	hWnd = CreateWindow(lpClassName, NULL, dwStyle, UcPos.x, UcPos.y, UcSize.cx, UcSize.cy, hWndUcParent, (HMENU)ID, hInst, NULL);
}

long UserControl::GetXpos()
{
	UserControl::GetWindowPos(hWndUcParent, hWnd, &UcPos.x, &UcPos.y);
	return UcPos.x;
}

void UserControl::SetXpos(long x)
{
	MoveWindow(hWnd, UcPos.x = x, UcPos.y, UcSize.cx, UcSize.cy, FALSE);
}

long UserControl::GetYpos()
{
	GetXpos();
	return UcPos.y;
}

void UserControl::SetYpos(long y)
{
	UcPos.y = y;
	SetXpos(UcPos.x);
}

long UserControl::GetWidth()
{
	UserControl::GetWindowSize(hWnd, &UcSize.cx, &UcSize.cy);
	return UcSize.cx;
}

void UserControl::SetWidth(long CX)
{
	SetWindowPos(hWnd, HWND_TOP, CW_USEDEFAULT, CW_USEDEFAULT, UcSize.cx = CX, UcSize.cy, SWP_NOMOVE);
	GetWidth();
}

long UserControl::GetHeight()
{
	GetWidth();
	return UcSize.cy;
}

void UserControl::SetHeight(long CY)
{
	UcSize.cy = CY;
	SetWidth(UcSize.cx);
}

void UserControl::SetText(TCHAR *lpText)
{
	SetWindowText(hWnd, lpText);
}

void UserControl::SetFont(HFONT *hFont)
{
	SendMessage(hWnd, WM_SETFONT, (WPARAM)*hFont, 0L);
}

HWND UserControl::GetHwnd()
{
	return hWnd;
}

void UserControl::GetWindowSize(HWND hWindow, long *iWidth, long *iHeight)
{
	RECT rect;
	GetWindowRect(hWindow, &rect);
	*iWidth = rect.right - rect.left;
	*iHeight = rect.bottom - rect.top;
}

void UserControl::GetWindowPos(HWND hWndParent, HWND hWindow, long *iX, long *iY)
{
	RECT clRect;
	GetWindowRect(hWindow, &clRect);
	POINT clPoint = {clRect.left, clRect.top};
	ScreenToClient(hWndParent, &clPoint);
	*iX = clPoint.x;
	*iY = clPoint.y;
}

void UserControl::SetXpos(double x)
{
	SetXpos(static_cast<long>(x));
}
void UserControl::SetYpos(double y)
{
	SetYpos(static_cast<long>(y));
}

void UserControl::SetWidth(double CX)
{
	SetWidth(static_cast<long>(CX));
}

void UserControl::SetHeight(double CY)
{
	SetHeight(static_cast<long>(CY));
}