
#include "winmain.h"
#include "File.h"
#include "SystemFont.h"
#include "UserControl.h"
#include <commctrl.h>
#pragma comment(lib, "ComCtl32.lib")

extern File Fl;
SystemFont *sf;

const int UIcount = 8;
UserControl *UC[UIcount];

void app_OnCreateUI(HWND hWnd, CREATESTRUCT cs)
{
	sf = new SystemFont(&hWnd, Fl.getString(TEXT("Pangramma")));
	if(!sf)
		return;

	for(int i = 0; i < UIcount; i++)
	{
		switch(i)
		{
		case 0:
			UC[i] = new UserControl(TEXT("BUTTON"), WS_CHILD | WS_VISIBLE | BS_GROUPBOX | BS_CENTER, hWnd, NULL, cs.hInstance);
			if(!UC[i])
				break;
			UC[i]->SetText(Fl.getString(TEXT("FrameText")));
			UC[i]->SetXpos(Fl.getNumber(TEXT("FrameXpos")) * sf->GetAverageLetterWidth());
			UC[i]->SetYpos(Fl.getNumber(TEXT("FrameYpos")) * sf->GetFontHeight());
			UC[i]->SetWidth(Fl.getNumber(TEXT("FrameCXsize")) * sf->GetAverageLetterWidth());
			UC[i]->SetHeight(Fl.getNumber(TEXT("FrameCYsize")) * sf->GetFontHeight());
			UC[i]->SetFont(sf->GetFont());
			break;
		case 1:
			UC[i] = new UserControl(TEXT("STATIC"), WS_CHILD | WS_VISIBLE, hWnd, NULL, cs.hInstance);
			if(!UC[i])
				break;
			UC[i]->SetText(Fl.getString(TEXT("StaticText")));
			UC[i]->SetXpos(Fl.getNumber(TEXT("StaticXpos")) * sf->GetAverageLetterWidth());
			UC[i]->SetYpos(Fl.getNumber(TEXT("StaticYpos")) * sf->GetFontHeight());
			UC[i]->SetWidth(Fl.getNumber(TEXT("StaticCXsize")) ? sf->GetAverageLetterWidth() * Fl.getNumber(TEXT("StaticCXsize")) : sf->GetTextWidth(Fl.getString(TEXT("StaticText"))));
			UC[i]->SetHeight(Fl.getNumber(TEXT("StaticCYsize")) * sf->GetFontHeight());
			UC[i]->SetFont(sf->GetFont());
			break;
		case 2:
			UC[i] = new UserControl(TEXT("BUTTON"), WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX, hWnd, NULL, cs.hInstance);
			if(!UC[i])
				break;
			UC[i]->SetText(Fl.getString(TEXT("CheckBoxText")));
			UC[i]->SetXpos(Fl.getNumber(TEXT("CheckBoxXpos")) * sf->GetAverageLetterWidth());
			UC[i]->SetYpos(Fl.getNumber(TEXT("CheckBoxYpos")) * sf->GetFontHeight());
			UC[i]->SetWidth(Fl.getNumber(TEXT("CheckBoxCXsize")) ? sf->GetAverageLetterWidth() * Fl.getNumber(TEXT("CheckBoxCXsize")) : sf->GetTextWidth(Fl.getString(TEXT("CheckBoxText"))));
			UC[i]->SetHeight(Fl.getNumber(TEXT("CheckBoxCYsize")) * sf->GetFontHeight());
			UC[i]->SetFont(sf->GetFont());
			break;
		case 3:
			UC[i] = new UserControl(TEXT("BUTTON"), WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTORADIOBUTTON, hWnd, NULL, cs.hInstance);
			if(!UC[i])
				break;
			UC[i]->SetText(Fl.getString(TEXT("RadioButtonText")));
			UC[i]->SetXpos(Fl.getNumber(TEXT("RadioButtonXpos")) * sf->GetAverageLetterWidth());
			UC[i]->SetYpos(Fl.getNumber(TEXT("RadioButtonYpos")) * sf->GetFontHeight());
			UC[i]->SetWidth(Fl.getNumber(TEXT("RadioButtonCXsize")) ? sf->GetAverageLetterWidth() * Fl.getNumber(TEXT("RadioButtonCXsize")) : sf->GetTextWidth(Fl.getString(TEXT("RadioButtonText"))));
			UC[i]->SetHeight(Fl.getNumber(TEXT("RadioButtonCYsize")) * sf->GetFontHeight());
			UC[i]->SetFont(sf->GetFont());
			break;
		case 4:
			UC[i] = new UserControl(TEXT("EDIT"), WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_AUTOHSCROLL, hWnd, NULL, cs.hInstance);
			if(!UC[i])
				break;
			UC[i]->SetText(Fl.getString(TEXT("EditText")));
			UC[i]->SetXpos(Fl.getNumber(TEXT("EditXpos")) * sf->GetAverageLetterWidth());
			UC[i]->SetYpos(Fl.getNumber(TEXT("EditYpos")) * sf->GetFontHeight());
			UC[i]->SetWidth(Fl.getNumber(TEXT("EditCXsize")) ? sf->GetAverageLetterWidth() * Fl.getNumber(TEXT("EditCXsize")) : sf->GetTextWidth(Fl.getString(TEXT("EditText"))));
			UC[i]->SetHeight(Fl.getNumber(TEXT("EditCYsize")) * sf->GetFontHeight());
			UC[i]->SetFont(sf->GetFont());
			break;
		case 5:
			{
			UC[i] = new UserControl(WC_TABCONTROL, WS_CHILD | WS_VISIBLE | WS_TABSTOP, hWnd, NULL, cs.hInstance);
			if(!UC[i])
				break;
			UC[i]->SetXpos(Fl.getNumber(TEXT("TabXpos")) * sf->GetAverageLetterWidth());
			UC[i]->SetYpos(Fl.getNumber(TEXT("TabYpos")) * sf->GetFontHeight());
			UC[i]->SetWidth(sf->GetAverageLetterWidth() * Fl.getNumber(TEXT("TabCXsize")));
			UC[i]->SetHeight(Fl.getNumber(TEXT("TabCYsize")) * sf->GetFontHeight());

			TCITEM tabPage = {0};
			tabPage.mask = TCIF_TEXT;

			TCHAR *Label[][2] = {TEXT("Tab1"), TEXT("Tab2")};

			for(int j = 0; j < 2; j++)
			{
				tabPage.pszText = Label[0][j];
				tabPage.cchTextMax = lstrlen(tabPage.pszText);
				SendMessage(UC[i]->GetHwnd(), TCM_INSERTITEM, j, (LPARAM)&tabPage);
			}
			UC[i]->SetFont(sf->GetFont());
			}
			break;
		case 7:
			{
			INITCOMMONCONTROLSEX icc;
			icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
			icc.dwICC = ICC_LINK_CLASS;
			InitCommonControlsEx(&icc);

			HWND hLink = CreateWindowW(
						WC_LINK,
						L"<A HREF=\"127.0.0.1\">127.0.0.1</A>",
						WS_CHILD | WS_VISIBLE | WS_TABSTOP,
						Fl.getNumber(TEXT("LinkXpos")) * sf->GetAverageLetterWidth(),
						Fl.getNumber(TEXT("LinkYpos")) * sf->GetFontHeight(), 
						Fl.getNumber(TEXT("LinkCXsize")) ? sf->GetAverageLetterWidth() * Fl.getNumber(TEXT("LinkCXsize")) : sf->GetTextWidth(Fl.getString(TEXT("LinkText"))),
						Fl.getNumber(TEXT("LinkCYsize")) * sf->GetFontHeight(),
						hWnd,
						NULL,
						cs.hInstance,
						NULL);

			SendMessage(hLink, WM_SETFONT, (WPARAM)*(sf->GetFont()), 0L);
			}
			break;
		default:
			UC[i] = NULL;
		}
	}
}

void app_Release()
{
	if(sf)
		delete sf;
	sf = NULL;
	for(int i = 0; i < UIcount; i++)
	{
		if(UC[i])
			delete UC[i];
		UC[i] = NULL;
	}
}
