
#include <tchar.h>
#include "winmain.h"
#include "File.h"

File Fl;

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
//#if _MSC_VER < 1600
	TCHAR szCurFolder[MAX_PATH], szFileName[MAX_PATH];
	memset(szCurFolder, '\0', sizeof(TCHAR) * MAX_PATH);
	GetModuleFileName(hInstance, szFileName, MAX_PATH);
	_tcsncpy(szCurFolder, szFileName, _tcsrchr(szFileName, '\\') - szFileName);
	SetCurrentDirectory(szCurFolder);
//#endif
	_tcscat(szCurFolder, TEXT("\\File.txt"));
	if(!Fl.Load(szCurFolder))
	{
		MessageBox(NULL, TEXT("File.txt not found or not avalible"), TEXT("Error"), MB_OK | MB_ICONERROR | MB_APPLMODAL);
		return -1;
	}

	WNDCLASS wcl;
	wcl.cbClsExtra = 0;
	wcl.cbWndExtra = 0;
	wcl.lpszMenuName = NULL;
	wcl.style = CS_HREDRAW | CS_VREDRAW;
	wcl.lpfnWndProc = WindowFunc;
	wcl.hInstance = hInstance;
	wcl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wcl.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcl.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wcl.lpszClassName = Fl.getString(TEXT("WinClassName"));

	if(!RegisterClass(&wcl))
		return -1;

	DWORD dwStyle;
	if(Fl.getBoolean(TEXT("FullScreen")))
	{
		dwStyle = WS_POPUPWINDOW | WS_MAXIMIZE;
		nCmdShow = SW_SHOWMAXIMIZED;
	}
	else
		dwStyle = WS_SYSMENU | WS_MINIMIZEBOX;

	HWND hWndMainWindow = CreateWindow(
			Fl.getString(TEXT("WinClassName")),
			Fl.getString(TEXT("ProgramTitle")),
			dwStyle,
			CW_USEDEFAULT, CW_USEDEFAULT,
			320, 240,//CW_USEDEFAULT, CW_USEDEFAULT,
			HWND_DESKTOP,
			NULL,
			hInstance,
			NULL);

	if(!hWndMainWindow)
		return -1;

	ShowWindow(hWndMainWindow, nCmdShow);
	UpdateWindow(hWndMainWindow);

	MSG msg;
	while(GetMessage(&msg, NULL, 0, 0) > 0)
		if(!IsDialogMessage(hWndMainWindow, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

	app_Release();

	return (int)msg.wParam;
}

LRESULT CALLBACK WindowFunc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_CREATE:
			app_OnCreateUI(hWnd, *(LPCREATESTRUCT)lParam);
		break;
#ifdef SAVE_STATIC
		case WM_CTLCOLORSTATIC:
		{
			TCHAR Class[64] = TEXT("");
			GetClassName((HWND)lParam, Class, 64);
			if((0 == lstrcmp(Class, TEXT("Static"))))
			{
				SetBkMode((HDC)wParam, TRANSPARENT);
				return (LRESULT)GetStockObject(NULL_BRUSH);
			}
		}
		break;
#endif
		case WM_CLOSE:
			DestroyWindow(hWnd);
		break;
		case WM_DESTROY:
			PostQuitMessage(0);
		break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}
